"""
A collection of monsters from D&D 5e's SRD

This file was autogenerated by https://github.com/stravajiaxen/5e-srd-to-py
"""

from dungeonsheets.monsters.monsters import Monster
from dungeonsheets.stats import Ability


class Kenku(Monster):
    """Ambusher.
      In the first round of a combat, the kenku has advantage on
      attack rolls against any creature it surprised.
    Mimicry.
      The kenku can mimic any sounds it has heard, including voices. A
      creature that hears the sounds can tell they are imitations with
      a successful DC 14 Wisdom (Insight) check.  ACTIONS
    
    # Actions
    
    Shortsword.
      Melee Weapon Attack: +5 to hit, reach 5 ft., one target. Hit: 6
      (1d6 + 3) piercing damage.
    Shortbow.
      Ranged Weapon Attack: +5 to hit, range 80/320 ft., one
      target. Hit: 6 (1d6 + 3) piercing damage.

    """
    name = 'Kenku'
    description = 'Medium humanoid (kenku), chaotic neutral'
    challenge_rating = 1/4
    armor_class = 13
    skills = 'Deception +4, Perception +2, Stealth +5'
    senses = 'passive Perception 12'
    languages = 'understands Auran and Common but speaks only through the use of its Mimicry trait'
    strength = Ability(10)
    dexterity = Ability(16)
    constitution = Ability(10)
    intelligence = Ability(11)
    wisdom = Ability(10)
    charisma = Ability(10)
    speed = 30
    swim_speed = 0
    fly_speed = 0
    climb_speed = 0
    burrow_speed = 0
    hp_max = 13
    hit_dice = '3d8'
    condition_immunities = ''
    damage_immunities = ''
    damage_resistances = ''
    damage_vulnerabilities = ''
    spells = []


class KillerWhale(Monster):
    """

    Echolocation.
      The whale can't use its blindsight while deafened.
    Hold Breath.
      The whale can hold its breath for 30 minutes
    Keen Hearing.
      The whale has advantage on Wisdom (Perception) checks that rely on
      hearing.

    # Actions

    Bite.
      Melee Weapon Attack: +6 to hit, reach 5 ft., one target. Hit: 21 (5d6
      + 4) piercing damage.
    """
    name = 'Killer Whale'
    description = 'Huge beast, unaligned'
    challenge_rating = 3
    armor_class = 12
    skills = 'Perception +3'
    senses = 'Blindsight 120 ft., Passive Perception 13'
    languages = ''
    strength = Ability(19)
    dexterity = Ability(10)
    constitution = Ability(13)
    intelligence = Ability(3)
    wisdom = Ability(12)
    charisma = Ability(7)
    speed = 0
    swim_speed = 60
    fly_speed = 0
    climb_speed = 0
    burrow_speed = 0
    hp_max = 90
    hit_dice = '12d12 + 12'
    condition_immunities = ''
    damage_immunities = ''
    damage_resistances = ''
    damage_vulnerabilities = ''
    spells = []


class Knight(Monster):
    """

    Brave.
      The knight has advantage on saving throws against being frightened.

    # Actions

    Multiattack.
      The knight makes two melee attacks.
    Greatsword.
      Melee Weapon Attack: +5 to hit, reach 5 ft., one target. Hit: 10 (2d6
      + 3) slashing damage.
    Heavy Crossbow.
      Ranged Weapon Attack: +2 to hit, range 100/400 ft., one target. Hit: 5
      (1d10) piercing damage.
    Leadership.
      For 1 minute, the knight can utter a special command or warning
      whenever a nonhostile creature that it can see within 30 ft. of it
      makes an attack roll or a saving throw. The creature can add a d4 to
      its roll provided it can hear and understand the knight. A creature
      can benefit from only one Leadership die at a time. This effect ends
      if the knight is incapacitated.

    # Reactions

    Parry.
      The knight adds 2 to its AC against one melee attack that would hit
      it. To do so, the knight must see the attacker and be wielding a melee
      weapon.
    """
    name = 'Knight'
    description = 'Medium humanoid, any alignment'
    challenge_rating = 3
    armor_class = 18
    skills = ''
    senses = 'Passive Perception 10'
    languages = 'any one language (usually Common)'
    strength = Ability(16)
    dexterity = Ability(11)
    constitution = Ability(14)
    intelligence = Ability(11)
    wisdom = Ability(11)
    charisma = Ability(15)
    speed = 30
    swim_speed = 0
    fly_speed = 0
    climb_speed = 0
    burrow_speed = 0
    hp_max = 52
    hit_dice = '8d8 + 16'
    condition_immunities = ''
    damage_immunities = ''
    damage_resistances = ''
    damage_vulnerabilities = ''
    spells = []


class Kobold(Monster):
    """

    Sunlight Sensitivity.
      While in sunlight, the kobold has disadvantage on attack rolls, as
      well as on Wisdom (Perception) checks that rely on sight.
    Pack Tactics.
      The kobold has advantage on an attack roll against a creature if at
      least one of the kobold's allies is within 5 ft. of the creature and
      the ally isn't incapacitated.

    # Actions

    Dagger.
      Melee Weapon Attack: +4 to hit, reach 5 ft., one target. Hit: 4 (1d4 +
      2) piercing damage.
    Sling.
      Ranged Weapon Attack: +4 to hit, range 30/120 ft., one target. Hit: 4
      (1d4 + 2) bludgeoning damage.
    """
    name = 'Kobold'
    description = 'Small humanoid, lawful evil'
    challenge_rating = 0.125
    armor_class = 12
    skills = ''
    senses = 'Darkvision 60 ft., Passive Perception 8'
    languages = 'Common, Draconic'
    strength = Ability(7)
    dexterity = Ability(15)
    constitution = Ability(9)
    intelligence = Ability(8)
    wisdom = Ability(7)
    charisma = Ability(8)
    speed = 30
    swim_speed = 0
    fly_speed = 0
    climb_speed = 0
    burrow_speed = 0
    hp_max = 5
    hit_dice = '2d6 + -2'
    condition_immunities = ''
    damage_immunities = ''
    damage_resistances = ''
    damage_vulnerabilities = ''
    spells = []


class Kraken(Monster):
    """

    Amphibious.
      The kraken can breathe air and water.
    Freedom of Movement.
      The kraken ignores difficult terrain, and magical effects can't reduce
      its speed or cause it to be restrained. It can spend 5 feet of
      movement to escape from nonmagical restraints or being grappled.
    Siege Monster.
      The kraken deals double damage to objects and structures.

    # Actions

    Multiattack.
      The kraken makes three tentacle attacks, each of which it can replace
      with one use of Fling.
    Bite.
      Melee Weapon Attack: +7 to hit, reach 5 ft., one target. Hit: 23 (3d8
      + 10) piercing damage. If the target is a Large or smaller creature
      grappled by the kraken, that creature is swallowed, and the grapple
      ends. While swallowed, the creature is blinded and restrained, it has
      total cover against attacks and other effects outside the kraken, and
      it takes 42 (12d6) acid damage at the start of each of the kraken's
      turns. If the kraken takes 50 damage or more on a single turn from a
      creature inside it, the kraken must succeed on a DC 25 Constitution
      saving throw at the end of that turn or regurgitate all swallowed
      creatures, which fall prone in a space within 10 feet of the kraken.
      If the kraken dies, a swallowed creature is no longer restrained by it
      and can escape from the corpse using 15 feet of movement, exiting
      prone.
    Tentacle.
      Melee Weapon Attack: +7 to hit, reach 30 ft., one target. Hit: 20 (3d6
      + 10) bludgeoning damage, and the target is grappled (escape DC 18).
      Until this grapple ends, the target is restrained. The kraken has ten
      tentacles, each of which can grapple one target.
    Fling.
      One Large or smaller object held or creature grappled by the kraken is
      thrown up to 60 feet in a random direction and knocked prone. If a
      thrown target strikes a solid surface, the target takes 3 (1d6)
      bludgeoning damage for every 10 feet it was thrown. If the target is
      thrown at another creature, that creature must succeed on a DC 18
      Dexterity saving throw or take the same damage and be knocked prone.
    Lightning Storm.
      The kraken magically creates three bolts of lightning, each of which
      can strike a target the kraken can see within 120 feet of it. A target
      must make a DC 23 Dexterity saving throw, taking 22 (4d10) lightning
      damage on a failed save, or half as much damage on a successful one.

    # Legendary Actions

    Tentacle Attack or Fling.
      The kraken makes one tentacle attack or uses its Fling.
    Lightning Storm (Costs 2 Actions).
      The kraken uses Lightning Storm.
    Ink Cloud (Costs 3 Actions).
      While underwater, the kraken expels an ink cloud in a 60-foot radius.
      The cloud spreads around corners, and that area is heavily obscured to
      creatures other than the kraken. Each creature other than the kraken
      that ends its turn there must succeed on a DC 23 Constitution saving
      throw, taking 16 (3d10) poison damage on a failed save, or half as
      much damage on a successful one. A strong current disperses the cloud,
      which otherwise disappears at the end of the kraken's next turn.
    """
    name = 'Kraken'
    description = 'Gargantuan monstrosity, chaotic evil'
    challenge_rating = 23
    armor_class = 18
    skills = ''
    senses = 'Truesight 120 ft., Passive Perception 14'
    languages = "understands Abyssal, Celestial, Infernal, and Primordial but can't speak, telepathy 120 ft."
    strength = Ability(30)
    dexterity = Ability(11)
    constitution = Ability(25)
    intelligence = Ability(22)
    wisdom = Ability(18)
    charisma = Ability(20)
    speed = 20
    swim_speed = 60
    fly_speed = 0
    climb_speed = 0
    burrow_speed = 0
    hp_max = 472
    hit_dice = '27d20 + 189'
    condition_immunities = 'frightened, paralyzed'
    damage_immunities = 'lightning, bludgeoning, piercing, and slashing from nonmagical weapons'
    damage_resistances = ''
    damage_vulnerabilities = ''
    spells = []


class KuoToa(Monster):
    """**Amphibious.** The kuo-toa can breathe air and water.

    **Otherworldly Perception.** The kuo-toa can sense the presence of
    any creature within 30 feet of it that is invisible or on the
    Ethereal Plane. It can pinpoint such a creature that is moving.

    **Slippery.** The kuo-toa has advantage on ability checks and
    saving throws made to escape a grapple.

    **Sunlight Sensitivity.** While in sunlight, the kuo-toa has
    disadvantage on attack rolls, as well as on Wisdom (Perception)
    checks that rely on sight.

    # Actions

    **Bite.** *Melee Weapon Attack:* +3 to hit, reach 5 ft., one
    target. *Hit:* 3 (1d4 + 1) piercing damage.

    **Spear.** *Melee or Ranged Weapon Attack:* +3 to hit, reach 5
    ft. or range 20/60 ft., one target. *Hit:* 4 (1d6 + 1) piercing
    damage, or 5 (1d8 + 1) piercing damage if used with two hands to
    make a melee attack.

    **Net.** *Ranged Weapon Attack:* +3 to hit, range 5/15 ft., one
    Large or smaller creature. *Hit:* The target is restrained. A
    creature can use its action to make a DC 10 Strength check to free
    itself or another creature in a net, ending the effect on a
    success. Dealing 5 slashing damage to the net (AC 10) frees the
    target without harming it and destroys the net.  REACTIONS

    **Sticky Shield.** When a creature misses the kuo-toa with a melee
    weapon attack, the kuo-toa uses its sticky shield to catch the
    weapon. The attacker must succeed on a DC 11 Strength saving
    throw, or the weapon becomes stuck to the kuo-toa's shield. If the
    weapon's wielder can't or won't let go of the weapon, the wielder
    is grappled while the weapon is stuck. While stuck, the weapon
    can't be used. A creature can pull the weapon free by taking an
    action to make a DC 11 Strength check and succeeding.
    """
    name = "Kuo-Toa"
    description = "Medium humanoid (kuo-toa), neutral evil"
    armor_class = 13
    hp_max = 18
    hit_dice = "4d8"
    speed = 30
    speed_swim = 30
    strength = Ability(13)
    dexterity = Ability(10)
    constitution = Ability(11)
    intelligence = Ability(11)
    wisdom = Ability(10)
    charisma = Ability(8)
    skills = "Perception +4"
    senses = "darkvision 120 ft., passive Perception 14"
    languages = "Undercommon"
    challenge_rating = 1 / 4


class KuoToaArchpriest(Monster):
    """**Amphibious.** The kuo-toa can breathe air and water.

    **Otherworldly Perception.** The kuo-toa can sense the presence of
    any creature within 30 feet of it that is invisible or on the
    Ethereal Plane. It can pinpoint such a creature that is moving.

    **Slippery.** The kuo-toa has advantage on ability checks and saving throws made to escape a grapple.

    **Sunlight Sensitivity.** While in sunlight, the kuo-toa has disadvantage on attack rolls, as well as on Wisdom (Perception) checks that rely on sight.

    **Spellcasting.** The kuo-toa is a 10th-level spellcaster. Its
    spellcasting ability is Wisdom (spell save DC 14, +6 to hit with
    spell attacks). The kuo-toa has the following cleric spells
    prepared:

    - Cantrips (at will): guidance, sacred flame, thaumaturgy
    - 1st level (4 slots): detect magic, sanctuary, shield of faith
    - 2nd level (3 slots): hold person, spiritual weapon
    - 3rd level (3 slots): spirit guardians, tongues
    - 4th level (3 slots): control water, divination
    - 5th level (2 slots): mass cure wounds, scrying

    # ACTIONS

    **Multiattack.** The kuo-toa makes two melee attacks.

    **Scepter.** *Melee Weapon Attack:* +6 to hit, reach 5 ft., one
    target. *Hit:* 6 (1d6 + 3) bludgeoning damage plus 14 (4d6)
    lightning damage.

    **Unarmed Strike.** *Melee Weapon Attack:* +6 to hit, reach 5 ft.,
    one target. *Hit:* 5 (1d4 + 3) bludgeoning damage.

    """
    name = "Kuo-Toa Archpriest"
    description = "Medium humanoid (kuo-toa), neutral evil"
    armor_class = 13
    hp_max = 97
    hit_dice = "13d8 + 39"
    speed = 30
    swim = 30
    strength = Ability(16)
    dexterity = Ability(14)
    constitution = Ability(16)
    intelligence = Ability(13)
    wisdom = Ability(16)
    charisma = Ability(14)
    skills = "Perception +9, Religion +6"
    senses = "darkvision 120 ft., passive Perception 19"
    languages = "Undercommon"
    challenge_rating = 6
    spells = [
        "guidance", "sacred flame", "thaumaturgy",
        "detect magic", "sanctuary", "shield of faith",
        "hold person", "spiritual weapon",
        "spirit guardians", "tongues",
        "control water", "divination",
        "mass cure wounds", "scrying",
    ]


class KuoToaMonitor(Monster):
    """**Amphibious.** The kuo-toa can breathe air and water.

    **Otherworldly Perception.** The kuo-toa can sense the presence of
    any creature within 30 feet of it that is invisible or on the
    Ethereal Plane. It can pinpoint such a creature that is moving.

    **Slippery.** The kuo-toa has advantage on ability checks and
    saving throws made to escape a grapple.

    **Sunlight Sensitivity.** While in sunlight, the kuo-toa has
    disadvantage on attack rolls, as well as on Wisdom (Perception)
    checks that rely on sight.

    **Unarmored Defense.** The kuo-toa adds its Wisdom modifier to its
    armor class.

    # Actions

    **Multiattack.** The kuo-toa makes one bite attack and two unarmed
    strikes.

    **Bite.** *Melee Weapon Attack:* +6 to hit, reach 5 ft., one
    target. *Hit:* 4 (1d4 + 2) piercing damage.

    **Unarmed Strike.** *Melee Weapon Attack:* +6 to hit, reach 5 ft.,
    one target. *Hit:* 5 (1d6 + 2) bludgeoning damage plus 3 (1d6)
    lightning damage, and the target can't take reactions until the
    end of the kuo-toa's next turn.
    """
    name = "Kuo-Toa Monitor"
    description = "Medium humanoid (kuo-toa), neutral evil"
    armor_class = 13
    hp_max = 65
    hit_dice = "10d8+20"
    speed = 30
    speed_swim = 30
    strength = Ability(14)
    dexterity = Ability(10)
    constitution = Ability(14)
    intelligence = Ability(14)
    wisdom = Ability(12)
    charisma = Ability(11)
    skills = "Perception +6, Religion +4"
    senses = "darkvision 120 ft., passive Perception 16"
    languages = "Undercommon"
    challenge_rating = 3


class KuoToaWhip(Monster):
    """**Amphibious.** The kuo-toa can breathe air and water.

    **Otherworldly Perception.** The kuo-toa can sense the presence of
    any creature within 30 feet of it that is invisible or on the
    Ethereal Plane. It can pinpoint such a creature that is moving.

    **Slippery.** The kuo-toa has advantage on ability checks and
    saving throws made to escape a grapple.

    **Sunlight Sensitivity.** While in sunlight, the kuo-toa has
    disadvantage on attack rolls, as well as on Wisdom (Perception)
    checks that rely on sight.

    **Spellcasting.** The kuo-toa is a 2nd-level spellcaster. Its
    spellcasting ability is Wisdom (spell save DC 12, +4 to hit with
    spell attacks). The kuo-toa has the following cleric spells
    prepared:

    - Cantrips (at will): sacred flame, thaumaturgy
    - 1st level (3 slots): bane, shield of faith

    # Actions

    **Multiattack.** The kuo-toa makes two attacks: one with its bite
    and one with its pincer staff.

    **Bite.** *Melee Weapon Attack:* +4 to hit, reach 5 ft., one
    target. *Hit:* 4 (1d4 + 2) piercing damage.

    **Pincer Staff.** *Melee Weapon Attack:* +4 to hit, reach 10 ft.,
    one target. *Hit:* 5 (1d6 + 2) piercing damage. If the target is a
    Medium or smaller creature, it is grappled (escape DC 14). Until
    this grapple ends, the kuo-toa can't use its pincer staff on
    another target.
    """
    name = "Kuo-Toa Whip"
    description = "Medium humanoid (kuo-toa), neutral evil"
    armor_class = 11
    hp_max = 65
    hit_dice = "10d8 + 20"
    strength = Ability(14)
    dexterity = Ability(10)
    constitution = Ability(14)
    intelligence = Ability(12)
    wisdom = Ability(14)
    charisma = Ability(11)
    skills = "Perception +6, Religion +4"
    senses = "darkvision 120 ft., passive Perception 16"
    languages = "Undercommon"
    challenge_rating = 1
    spells = ["sacred flame", "thaumaturgy",
              "bane", "shield of faith", ]
